/* essential header cards for funtools, taken from chandra/acis/hrc headers */

static char *_prim="SIMPLE  =                    T  /  FITS STANDARD                                BITPIX  =                    8  /  Binary Data                                  NAXIS   =                    0  /  No image data array present                  EXTEND  =                    T  /  There may be standard extensions             EVENT   = 'EVENTS  '            /  A3D table containing event record            END                                                                             ";

static char *_extn="XTENSION= 'BINTABLE'           / binary table extension                         BITPIX  =                    8 / 8-bit bytes                                    NAXIS   =                    2 / 2-dimensional binary table                     NAXIS1  =                  136 / width of table in bytes                        NAXIS2  =                    0 / number of rows in table                        PCOUNT  =                    0 / size of special data area                      GCOUNT  =                    1 / one data group (required keyword)              TFIELDS =                   44 / number of fields in each row                   EXTNAME = 'EVENTS  '           / name of this binary table extension            HDUNAME = 'EVENTS  '           / ASCDM block name                               TTYPE1  = 'time    '           / S/C TT corresponding to mid-exposure           TFORM1  = '1D      '           / format of field                                TUNIT1  = 's       '                                                            TTYPE2  = 'ccd_id  '           / CCD reporting event                            TFORM2  = '1I      '           / format of field                                TLMIN2  =                    0                                                  TLMAX2  =                    9                                                  TTYPE3  = 'node_id '           / CCD serial readout amplifier node              TFORM3  = '1I      '           / format of field                                TLMIN3  =                    0                                                  TLMAX3  =                    3                                                  TTYPE4  = 'expno   '           / Exposure number of CCD frame containing event  TFORM4  = '1J      '           / format of field                                TLMIN4  =                    0                                                  TTYPE5  = 'chipx   '           / Chip coords                                    TFORM5  = '1I      '           / format of field                                TUNIT5  = 'pixel   '                                                            TTYPE6  = 'chipy   '           / Chip coords                                    TFORM6  = '1I      '           / format of field                                TUNIT6  = 'pixel   '                                                            TLMIN5  =                    1                                                  TLMAX5  =                 1024                                                  TLMIN6  =                    1                                                  TLMAX6  =                 1024                                                  TTYPE7  = 'tdetx   '           / ACIS tiled detector coordinates                TFORM7  = '1I      '           / format of field                                TUNIT7  = 'pixel   '                                                            TTYPE8  = 'tdety   '           / ACIS tiled detector coordinates                TFORM8  = '1I      '           / format of field                                TUNIT8  = 'pixel   '                                                            TLMIN7  =                    1                                                  TLMAX7  =                 8192                                                  TLMIN8  =                    1                                                  TLMAX8  =                 8192                                                  TTYPE9  = 'detx    '           / ACIS detector coordinates                      TFORM9  = '1E      '           / format of field                                TUNIT9  = 'pixel   '                                                            TLMIN9  =        5.0000000E-01                                                  TLMAX9  =        8.1925000E+03                                                  TTYPE10 = 'dety    '           / ACIS detector coordinates                      TFORM10 = '1E      '           / format of field                                TUNIT10 = 'pixel   '                                                            TLMIN10 =        5.0000000E-01                                                  TLMAX10 =        8.1925000E+03                                                  TTYPE11 = 'x       '           / sky coordinates                                TFORM11 = '1E      '           / format of field                                TUNIT11 = 'pixel   '                                                            TLMIN11 =        5.0000000E-01                                                  TLMAX11 =        8.1925000E+03                                                  TTYPE12 = 'y       '           / sky coordinates                                TFORM12 = '1E      '           / format of field                                TUNIT12 = 'pixel   '                                                            TLMIN12 =        5.0000000E-01                                                  TLMAX12 =        8.1925000E+03                                                  TTYPE13 = 'pha     '           / total pulse height of event                    TFORM13 = '1J      '           / format of field                                TUNIT13 = 'adu     '                                                            TLMIN13 =                    0                                                  TLMAX13 =                36855                                                  TNULL13 =                    0                                                  TTYPE14 = 'energy  '           / nominal energy of event (eV)                   TFORM14 = '1E      '           / format of field                                TUNIT14 = 'eV      '                                                            TLMIN14 =        0.0000000E+00                                                  TLMAX14 =        1.0000000E+06                                                  TTYPE15 = 'pi      '           / pulse invariant energy of event                TFORM15 = '1J      '           / format of field                                TUNIT15 = 'chan    '                                                            TLMIN15 =                    1                                                  TLMAX15 =                 1024                                                  TNULL15 =                    0                                                  TTYPE16 = 'fltgrade'           / event grade, flight system                     TFORM16 = '1I      '           / format of field                                TLMIN16 =                    0                                                  TLMAX16 =                  255                                                  TTYPE17 = 'grade   '           / binned event grade                             TFORM17 = '1I      '           / format of field                                TLMIN17 =                    0                                                  TLMAX17 =                    7                                                  TTYPE18 = 'status  '           / event status bits                              TFORM18 = '32X     '           / format of field                                TTYPE19 = 'xtime             ' / Label for field                                TFORM19 = '1D                ' / Data type for field                            TUNIT19 = 's                 ' / axis units                                     TTYPE20 = 'crsv              ' / Label for field                                TFORM20 = '1I                ' / Data type for field                            TLMIN20 =                    0 / Min. axis value                                TLMAX20 =                   63 / Max. axis value                                TTYPE21 = 'crsu              ' / Label for field                                TFORM21 = '1I                ' / Data type for field                            TLMIN21 =                    0 / Min. axis value                                TLMAX21 =                   63 / Max. axis value                                TTYPE22 = 'amp_sf            ' / Label for field                                TFORM22 = '1I                ' / Data type for field                            TLMIN22 =                    0 / Min. axis value                                TLMAX22 =                    3 / Max. axis value                                TTYPE23 = 'av1               ' / Label for field                                TFORM23 = '1I                ' / Data type for field                            TLMIN23 =                    0 / Min. axis value                                TLMAX23 =                 4095 / Max. axis value                                TTYPE24 = 'av2               ' / Label for field                                TFORM24 = '1I                ' / Data type for field                            TLMIN24 =                    0 / Min. axis value                                TLMAX24 =                 4095 / Max. axis value                                TTYPE25 = 'av3               ' / Label for field                                TFORM25 = '1I                ' / Data type for field                            TLMIN25 =                    0 / Min. axis value                                TLMAX25 =                 4095 / Max. axis value                                TTYPE26 = 'au1               ' / Label for field                                TFORM26 = '1I                ' / Data type for field                            TLMIN26 =                    0 / Min. axis value                                TLMAX26 =                 4095 / Max. axis value                                TTYPE27 = 'au2               ' / Label for field                                TFORM27 = '1I                ' / Data type for field                            TLMIN27 =                    0 / Min. axis value                                TLMAX27 =                 4095 / Max. axis value                                TTYPE28 = 'au3               ' / Label for field                                TFORM28 = '1I                ' / Data type for field                            TLMIN28 =                    0 / Min. axis value                                TLMAX28 =                 4095 / Max. axis value                                TTYPE29 = 'rawx              ' / Label for field                                TFORM29 = '1J                ' / Data type for field                            TLMIN29 =                    0 / Min. axis value                                TLMAX29 =                16383 / Max. axis value                                TUNIT29 = 'pixel             ' / axis units                                     TTYPE30 = 'rawy              ' / Label for field                                TFORM30 = '1J                ' / Data type for field                            TLMIN30 =                    0 / Min. axis value                                TLMAX30 =                16383 / Max. axis value                                TUNIT30 = 'pixel             ' / axis units                                     TTYPE31 = 'xchipx            ' / Label for field                                TFORM31 = '1I                ' / Data type for field                            TLMIN31 =                    1 / Min. axis value                                TLMAX31 =                16384 / Max. axis value                                TUNIT31 = 'pixel             ' / axis units                                     TTYPE32 = 'xchipy            ' / Label for field                                TFORM32 = '1I                ' / Data type for field                            TLMIN32 =                    1 / Min. axis value                                TLMAX32 =                16384 / Max. axis value                                TUNIT32 = 'pixel             ' / axis units                                     TTYPE33 = 'xtdetx            ' / Label for field                                TFORM33 = '1J                ' / Data type for field                            TLMIN33 =                    1 / Min. axis value                                TLMAX33 =                16384 / Max. axis value                                TUNIT33 = 'pixel             ' / axis units                                     TTYPE34 = 'xtdety            ' / Label for field                                TFORM34 = '1J                ' / Data type for field                            TLMIN34 =                    1 / Min. axis value                                TLMAX34 =                16384 / Max. axis value                                TUNIT34 = 'pixel             ' / axis units                                     TTYPE35 = 'xdetx             ' / Label for field                                TFORM35 = '1E                ' / Data type for field                            TLMIN35 =            0.5000000 / Min. axis value                                TLMAX35 =        32768.5000000 / Max. axis value                                TUNIT35 = 'pixel             ' / axis units                                     TTYPE36 = 'xdety             ' / Label for field                                TFORM36 = '1E                ' / Data type for field                            TLMIN36 =            0.5000000 / Min. axis value                                TLMAX36 =        32768.5000000 / Max. axis value                                TUNIT36 = 'pixel             ' / axis units                                     TTYPE37 = 'xx                ' / Label for field                                TFORM37 = '1E                ' / Data type for field                            TLMIN37 =            0.5000000 / Min. axis value                                TLMAX37 =        32768.5000000 / Max. axis value                                TUNIT37 = 'pixel             ' / axis units                                     TTYPE38 = 'xy                ' / Label for field                                TFORM38 = '1E                ' / Data type for field                            TLMIN38 =            0.5000000 / Min. axis value                                TLMAX38 =        32768.5000000 / Max. axis value                                TUNIT38 = 'pixel             ' / axis units                                     TTYPE39 = 'xpha              ' / Label for field                                TFORM39 = '1I                ' / Data type for field                            TLMIN39 =                    0 / Min. axis value                                TLMAX39 =                  255 / Max. axis value                                TUNIT39 = 'chan              ' / axis units                                     TTYPE40 = 'xpi               ' / Label for field                                TFORM40 = '1I                ' / Data type for field                            TLMIN40 =                    0 / Min. axis value                                TLMAX40 =                  255 / Max. axis value                                TUNIT40 = 'chan              ' / axis units                                     TTYPE41 = 'sumamps           ' / Label for field                                TFORM41 = '1I                ' / Data type for field                            TLMIN41 =                    0 / Min. axis value                                TLMAX41 =                24570 / Max. axis value                                TTYPE42 = 'chip_id           ' / Label for field                                TFORM42 = '1I                ' / Data type for field                            TTYPE43 = 'xstatus           ' / Label for field                                TFORM43 = '32X               ' / Data type for field                            TTYPE44 = 'screen_status     ' / Label for field                                TFORM44 = '1I                ' / Data type for field                            EQUINOX =  2.0000000000000E+03 / default                                        RADECSYS= 'ICRS    '           / default                                        TCTYP5  = 'CPCX    '                                                            TCRVL5  =  0.0000000000000E+00                                                  TCRPX5  =  5.0000000000000E-01                                                  TCDLT5  =  2.3987000000000E-02                                                  TCUNI5  = 'mm      '                                                            TCTYP6  = 'CPCY    '                                                            TCRVL6  =  0.0000000000000E+00                                                  TCRPX6  =  5.0000000000000E-01                                                  TCDLT6  =  2.3987000000000E-02                                                  TCUNI6  = 'mm      '                                                            TCTYP9  = 'LONG-TAN'                                                            TCRVL9  =  0.0000000000000E+00                                                  TCRPX9  =  4.0965000000000E+03                                                  TCDLT9  =  1.3666666666667E-04                                                  TCNAM9  = 'PHI     '                                                            TCUNI9  = 'deg     '                                                            TCTYP10 = 'NPOL-TAN'                                                            TCRVL10 =  0.0000000000000E+00                                                  TCRPX10 =  4.0965000000000E+03                                                  TCDLT10 =  1.3666666666667E-04                                                  TCNAM10 = 'THETA   '                                                            TCUNI10 = 'deg     '                                                            TCTYP11 = 'RA---TAN'                                                            TCRVL11 =  2.1953403149343E+02                                                  TCRPX11 =  4.0965000000000E+03                                                  TCDLT11 = -1.3666666666667E-04                                                  TCUNI11 = 'deg     '                                                            TCTYP12 = 'DEC--TAN'                                                            TCRVL12 =  3.4275710651498E+01                                                  TCRPX12 =  4.0965000000000E+03                                                  TCDLT12 =  1.3666666666667E-04                                                  TCUNI12 = 'deg     '                                                            END                                                                             ";
